//+------------------------------------------------------------------+
//|                                              VilkaChuwashowa.mq4 |
//|                                                           Rodion |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Rodion"
#property link      ""
#property indicator_buffers 3
#include <stdlib.mqh>

extern bool       Alarmset=true;
extern double     Lot= 0.1;
extern int        StopLoss = 30;
extern int        TakeProfit = 250;
extern bool       TSProfitOnly = True;     //   
extern int        TStop.Buy    = 50;       //      
extern int        TStop.Sell   = 35;       //      
extern int        TrailingStep = 3;        //    

//-------     ------------------------------+

bool   UseSound     = False;          //   
string SoundSuccess = "expert.wav";  //  
string SoundError   = "timeout.wav"; //  
int    NumberOfTry  = 3;             //   
bool   AllSymbols   = False;     //     
int    Magic        = -1;       //  
bool   ShowComment  = True;     //  
//-------    -------------------------------------+
bool   gbDisabled   = False;           //   
bool   gbNoInit     = False;           //   
color  clModifyBuy  = Aqua;            //    
color  clModifySell = Tomato;          //    

int               MG;
extern string Ind_Coment1= "---    ---";
extern bool  ShowFractals     =  true;         // /  
extern bool  OnAlert          = false;         // / 
extern bool  OnPrint          = false;         // /     
extern int   nVilka.Upper     =     1;         //    ""
extern int   nVilka.Lower     =     1;         //    ""
extern color Color.LineUpper  =   Red;         //   ""
extern color Color.LineLower  =  Blue;         //   ""
extern int   Width.LineUpper  =     2;         //   ""
extern int   Width.LineLower  =     2;         //   ""
extern string Ind_Coment2= "---    ---";
extern bool  ShowOrders       =  true;         // /  
extern bool  OnAlert.Orders   =  true;         // / 
extern color Color.OrderBuy   =  Blue;         //    
extern color Color.OrderSell  = Green;         //    
extern int   Width.OrderBuy   =     2;         //    
extern int   Width.OrderSell  =     2;         //    
extern color Color.SLBuy      =   Red;         //    
extern color Color.SLSell     =   Red;         //    
extern int   Orders.FontSize  =    12;         //   
extern string Ind_Coment3= "---  E-mail  ---";
extern bool  SendEnter        = false;         //  Buy, Sell
extern bool  SendLoss         = false;         //  StopLoss
//+---------------------------------------------------------------------------+
//  
int          nLine.Upper      =     0,         //   ,  
             nLine.Lower      =     0,         //   ,  
             nBars            =     0;         //
datetime     mLineUpper.DateTime[][2];         //     ""
         //  mLineUpper.DateTime[i][0]         //   
         //  mLineUpper.DateTime[i][1]         //   
double       mLineUpper.Price[][2];            //     ""
         //  mLineUpper.Price[i][0]            //   
         //  mLineUpper.Price[i][1]            //   
datetime     mLineLower.DateTime[][2];         //     ""
         //  mLineLower.DateTime[i][0]         //   
         //  mLineLower.DateTime[i][1]         //   
double       mLineLower.Price[][2];            //     ""
         //  mLineLower.Price[i][0]            //   
         //  mLineLower.Price[i][1]            //   
string       mOrders[2][5];                    //    "" 
         //  mOrders[0][0]                     // Buy - 0- , 10- 
         //  mOrders[1][0]                     // Sell- 0- , 20- 
         //  mOrders[i][1]                     //    "" 
         //  mOrders[i][2]                     //   
         //  mOrders[i][3]                     //   
         //  mOrders[i][4]                     // 0-  , 1- 
string       NameLine.Buy="";                  //      
string       NameLine.Sell="";                 //      
//----- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];

//+---------------------------------------------------------------------------+
int init()
  {
  MG=StringGetChar(Symbol(),0)+StringGetChar(Symbol(),3)+231;
      
  int Qnt=ObjectsTotal();
  // ----- Indicators Properties
  SetIndexStyle(0,DRAW_ARROW);
  SetIndexArrow(0,217);
  SetIndexBuffer(0,ExtMapBuffer1);
  SetIndexEmptyValue(0,0.0);
  SetIndexStyle(1,DRAW_ARROW);
  SetIndexArrow(1,218);
  SetIndexBuffer(1,ExtMapBuffer2);
  SetIndexEmptyValue(1,0.0);
  // ----- Name for DataWindow and indicator subwindow label
  IndicatorShortName("Fractals");
  SetIndexLabel(0,"FractalsUp");
  SetIndexLabel(1,"FractalsDown");
  // -----       
  ArrayResize(mLineUpper.DateTime,nVilka.Upper*2); ArrayResize(mLineUpper.Price,nVilka.Upper*2);
  ArrayResize(mLineLower.DateTime,nVilka.Lower*2); ArrayResize(mLineLower.Price,nVilka.Lower*2);
  // -----      
  if (nVilka.Lower==1) NameLine.Buy ="Line.Lower1";
  if (nVilka.Lower>1)  NameLine.Buy ="Line.Lower"+DoubleToStr(nVilka.Lower*2-1,0);
  if (nVilka.Upper==1) NameLine.Sell="Line.Upper1";
  if (nVilka.Upper>1)  NameLine.Sell="Line.Upper"+DoubleToStr(nVilka.Upper*2-1,0);
  
  return;
}


//+---------------------------------------------------------------------------+
void deinit()   {     // Custom indicator deinitialization function
int    Qnt=ObjectsTotal();
  // -----   
  for (int i=0; i<Qnt; i++)   {  //   
    if(StringFind(ObjectName(i),"Line.Upper",0)>=0) {
      ObjectDelete(ObjectName(i));     //  
      i--; continue;
    }
    if(StringFind(ObjectName(i),"Line.Lower",0)>=0) {
      ObjectDelete(ObjectName(i));     //  
      i--; continue;
    }
    if(i>=ObjectsTotal()) break;
  }
  DeleteOrders(10); DeleteOrders(20);
 return;
}
///+------------------------------------------------------------------+

void start() {        // Custom indicator iteration function
int    counted_bars=IndicatorCounted();
int    limit;
string sy=IIFs(AllSymbols, "", NULL);SimpleTrailing(sy, -1, Magic);
int    Spred=MarketInfo(Symbol(),MODE_SPREAD);
  // -----    
  if(!CheckParameters()) return;
  // -----    
  if(!isNewBar()) return;
  // -----     
  if (counted_bars>0) counted_bars--;
  limit=Bars-counted_bars;
  // -----  
  //for (int i=limit; i>2; i--)   {
  for (int i=limit; i>=0; i--)   
  {
    if(ShowFractals)  
    {                    //    
      ExtMapBuffer1[i]=iFractals(NULL,0,MODE_UPPER,i)+Spred*Point;
      ExtMapBuffer2[i]=iFractals(NULL,0,MODE_LOWER,i)-Spred*Point;
    }
    //----  Upper- ( "")
    if (iFractals(NULL,0,MODE_UPPER,i)!=0)  {
      if(LowerVilka(i)) {
        if(i==0)  {
          if(OnAlert) Alert(Symbol(),Period(),"  ! ",TimeToStr(Time[i],TIME_DATE|TIME_SECONDS));
          if(OnPrint) Print(Symbol(),Period(),"  ! ",TimeToStr(Time[i],TIME_DATE|TIME_SECONDS));
        }
      }
    }
    //----  Lower- ( "")
    if (iFractals(NULL,0,MODE_LOWER,i)!=0)  {
      if(UpperVilka(i)) {
        if(i==0)  {
          if(OnAlert) Alert(Symbol(),Period(),"  ! ",TimeToStr(Time[i],TIME_DATE|TIME_SECONDS));
          if(OnPrint) Print(Symbol(),Period(),"  ! ",TimeToStr(Time[i],TIME_DATE|TIME_SECONDS));
        }
      }
    }
    //-----   "" -   
    if((StrToDouble(mOrders[0][0])==0 || (StrToDouble(mOrders[0][0])==10 && StrToDouble(mOrders[0][4])==1)) && 
       (Close[i+1]>ObjectGetValueByShift(NameLine.Buy,i+1) || Open[i]>ObjectGetValueByShift(NameLine.Buy,i)))  {
      if(DrawOrdersBuy(i))  
      {
        if(OnAlert.Orders)  
        {
          if(i==0 && colOrders(OP_BUY)==0)  
          {
          Alert(Symbol(),Period(),":   ! ",TimeToStr(Time[i],TIME_DATE|TIME_SECONDS));
          OrderCl(OP_BUY); 
          OrderOp(OP_BUY, Symbol(), TakeProfit, StopLoss, Lot);
          }
        }
        if(SendEnter)  
        {
          if(i==0)  
          {
            SendMailSignals(i, 10);
          }
        }        
      }
    }
    //-----     
    if(StrToDouble(mOrders[0][0])==10 && StrToDouble(mOrders[0][4])==0 && 
      (StrToDouble(mOrders[0][3])>=Low[i+1] || StrToDouble(mOrders[0][3])>=Open[i]))  {
      // -----    
      mOrders[0][4]=1;
      // ----- 
      if(OnAlert.Orders)  
      {
        if(i==0)  
        {
          Alert(Symbol(),Period(),":     Buy! ",TimeToStr(Time[i],TIME_DATE|TIME_SECONDS));
        }
      }
      if(SendLoss)  
      {
        if(i==0)  
        {
          SendMailSignals(i, 11);
        }
      }        
    }
    //-----   "" -   
    if((StrToDouble(mOrders[1][0])==0 || (StrToDouble(mOrders[1][0])==20 && StrToDouble(mOrders[1][4])==1)) &&
       (Close[i+1]<ObjectGetValueByShift(NameLine.Sell,i+1) || Open[i]<ObjectGetValueByShift(NameLine.Sell,i)))  {
      if(DrawOrdersSell(i))  {
        if(OnAlert.Orders)  {
          if(i==0 && colOrders(OP_SELL)==0)  
          {
          Alert(Symbol(),Period(),":   ! ",TimeToStr(Time[i],TIME_DATE|TIME_SECONDS));
          OrderCl(OP_SELL);
          OrderOp(OP_SELL, Symbol(), TakeProfit, StopLoss, Lot);
          }
        }
        if(SendEnter)  
        {
          if(i==0)  
          {
            SendMailSignals(i, 20);
          }
        }        
      }
    }
    //-----     
    if(StrToDouble(mOrders[1][0])==20 && StrToDouble(mOrders[1][4])==0 && 
      (StrToDouble(mOrders[1][3])<=High[i+1] || StrToDouble(mOrders[1][3])<=Open[i]))  {
      // -----    
      mOrders[1][4]=1;
      // ----- 
      if(OnAlert.Orders)  
      {
        if(i==0)  
        {
          Alert(Symbol(),Period(),":     Sell! ",TimeToStr(Time[i],TIME_DATE|TIME_SECONDS));
        }
      }
      if(SendLoss)  {
        if(i==0)  {
          SendMailSignals(i, 21);
        }
      }        
    }
  }
  return;
}

//+------------------------------------------------------------------+
//+---------------------------------------------------------------------------+
bool UpperVilka(int nBar)  {     //      ""
int         j=0;
double      Fractal.Lower=0;
double      mFractals.Price[3];
datetime    mFractals.DateTime[3];
   // -----       
   ArrayInitialize(mFractals.Price,0); ArrayInitialize(mFractals.DateTime,0);
   for (int i=nBar; i<Bars; i++)   {  //   
      Fractal.Lower=iFractals(NULL,0,MODE_LOWER,i);
      if(Fractal.Lower!=0) {
         mFractals.Price[j]=Fractal.Lower-MarketInfo(Symbol(),MODE_SPREAD)*Point;
         mFractals.DateTime[j]=Time[i];
         j++;
      }
      if(j>2) break;
   }
   // -----   ""
   if(mFractals.Price[2]<mFractals.Price[1] && mFractals.Price[1]<mFractals.Price[0])  {
      string Name1="Line.Upper"+DoubleToStr(nLine.Upper,0); nLine.Upper++;
      string Name2="Line.Upper"+DoubleToStr(nLine.Upper,0); nLine.Upper++;

      ObjectCreate(Name1,OBJ_TREND,0,mFractals.DateTime[2],mFractals.Price[2],mFractals.DateTime[1],mFractals.Price[1]);
      ObjectCreate(Name2,OBJ_TREND,0,mFractals.DateTime[1],mFractals.Price[1],mFractals.DateTime[0],mFractals.Price[0]);
      if (ObjectGetValueByShift(Name1,nBar)<ObjectGetValueByShift(Name2,nBar))  {
        ObjectDelete(Name1); ObjectDelete(Name2); nLine.Upper--; nLine.Upper--; return(false);
      }
      ObjectSet(Name1,OBJPROP_COLOR,Color.LineUpper);   ObjectSet(Name2,OBJPROP_COLOR,Color.LineUpper);
      ObjectSet(Name1,OBJPROP_WIDTH,Width.LineUpper);   ObjectSet(Name2,OBJPROP_WIDTH,Width.LineUpper);
      ObjectSet(Name1,OBJPROP_RAY,True);                ObjectSet(Name2,OBJPROP_RAY,True);
      CheckNumVilka(10);
      // -----     
      DeleteOrders(20);
      return(true);
   }
   return(false);
}

//+---------------------------------------------------------------------------+
bool LowerVilka(int nBar)  {     //      ""
int         j=0;
double      Fractal.Upper=0;
double      mFractals.Price[3];
datetime    mFractals.DateTime[3];
   // -----       
   ArrayInitialize(mFractals.Price,0); ArrayInitialize(mFractals.DateTime,0);
   for (int i=nBar; i<Bars; i++)   {  //   
      Fractal.Upper=iFractals(NULL,0,MODE_UPPER,i);
      if(Fractal.Upper!=0) {
         mFractals.Price[j]=Fractal.Upper+MarketInfo(Symbol(),MODE_SPREAD)*Point;
         mFractals.DateTime[j]=Time[i];
         j++;
      }
      if(j>2) break;
   }
   // -----   ""
   if(mFractals.Price[2]>mFractals.Price[1] && mFractals.Price[1]>mFractals.Price[0])  {
      string Name1="Line.Lower"+DoubleToStr(nLine.Lower,0); nLine.Lower++;
      string Name2="Line.Lower"+DoubleToStr(nLine.Lower,0); nLine.Lower++;

      ObjectCreate(Name1,OBJ_TREND,0,mFractals.DateTime[2],mFractals.Price[2],mFractals.DateTime[1],mFractals.Price[1]);
      ObjectCreate(Name2,OBJ_TREND,0,mFractals.DateTime[1],mFractals.Price[1],mFractals.DateTime[0],mFractals.Price[0]);
      if (ObjectGetValueByShift(Name1,nBar)>ObjectGetValueByShift(Name2,nBar))  {
        ObjectDelete(Name1); ObjectDelete(Name2); nLine.Lower--; nLine.Lower--; return(false);
      }
      ObjectSet(Name1,OBJPROP_COLOR,Color.LineLower);   ObjectSet(Name2,OBJPROP_COLOR,Color.LineLower);
      ObjectSet(Name1,OBJPROP_WIDTH,Width.LineLower);   ObjectSet(Name2,OBJPROP_WIDTH,Width.LineLower);
      ObjectSet(Name1,OBJPROP_RAY,True);                ObjectSet(Name2,OBJPROP_RAY,True);
      CheckNumVilka(20);
      // -----     
      DeleteOrders(10);
      return(true);
   }
   return(false);
}

//+---------------------------------------------------------------------------+
bool isNewBar() {                     //   true,    ,  false
  if(nBars!=Bars) {
    nBars=Bars; return(true);
  }
  return(false);
}

//+---------------------------------------------------------------------------+
void CheckNumVilka(int Type)  {     //       
int i;
  switch(Type)  {
    case 10:
      //--------------------------------------------------------- 1 --
      if(nLine.Upper<=nVilka.Upper*2)  {
        mLineUpper.DateTime[nLine.Upper-2][0]=ObjectGet("Line.Upper"+(nLine.Upper-2),OBJPROP_TIME1);
        mLineUpper.DateTime[nLine.Upper-2][1]=ObjectGet("Line.Upper"+(nLine.Upper-2),OBJPROP_TIME2);
        mLineUpper.Price[nLine.Upper-2][0]=ObjectGet("Line.Upper"+(nLine.Upper-2),OBJPROP_PRICE1);
        mLineUpper.Price[nLine.Upper-2][1]=ObjectGet("Line.Upper"+(nLine.Upper-2),OBJPROP_PRICE2);
        //+------------------------------------------------------------------+
        mLineUpper.DateTime[nLine.Upper-1][0]=ObjectGet("Line.Upper"+(nLine.Upper-1),OBJPROP_TIME1);
        mLineUpper.DateTime[nLine.Upper-1][1]=ObjectGet("Line.Upper"+(nLine.Upper-1),OBJPROP_TIME2);
        mLineUpper.Price[nLine.Upper-1][0]=ObjectGet("Line.Upper"+(nLine.Upper-1),OBJPROP_PRICE1);
        mLineUpper.Price[nLine.Upper-1][1]=ObjectGet("Line.Upper"+(nLine.Upper-1),OBJPROP_PRICE2);
      }
      //--------------------------------------------------------- 2 --
      if(nLine.Upper >nVilka.Upper*2)  {
        for (i=0; i<nLine.Upper-4; i++)  {
          mLineUpper.DateTime[i][0]=mLineUpper.DateTime[i+2][0]; mLineUpper.DateTime[i][1]=mLineUpper.DateTime[i+2][1];
          mLineUpper.Price[i][0]=mLineUpper.Price[i+2][0]; mLineUpper.Price[i][1]=mLineUpper.Price[i+2][1];
        }
        mLineUpper.DateTime[nLine.Upper-4][0]=ObjectGet("Line.Upper"+(nLine.Upper-2),OBJPROP_TIME1);
        mLineUpper.DateTime[nLine.Upper-4][1]=ObjectGet("Line.Upper"+(nLine.Upper-2),OBJPROP_TIME2);
        mLineUpper.Price[nLine.Upper-4][0]=ObjectGet("Line.Upper"+(nLine.Upper-2),OBJPROP_PRICE1);
        mLineUpper.Price[nLine.Upper-4][1]=ObjectGet("Line.Upper"+(nLine.Upper-2),OBJPROP_PRICE2);
        //+------------------------------------------------------------------+
        mLineUpper.DateTime[nLine.Upper-3][0]=ObjectGet("Line.Upper"+(nLine.Upper-1),OBJPROP_TIME1);
        mLineUpper.DateTime[nLine.Upper-3][1]=ObjectGet("Line.Upper"+(nLine.Upper-1),OBJPROP_TIME2);
        mLineUpper.Price[nLine.Upper-3][0]=ObjectGet("Line.Upper"+(nLine.Upper-1),OBJPROP_PRICE1);
        mLineUpper.Price[nLine.Upper-3][1]=ObjectGet("Line.Upper"+(nLine.Upper-1),OBJPROP_PRICE2);
        //+------------------------------------------------------------------+
        ObjectDelete("Line.Upper"+(nLine.Upper-2)); ObjectDelete("Line.Upper"+(nLine.Upper-1));
        nLine.Upper--;nLine.Upper--;
        //+------------------------------------------------------------------+
        for (i=0; i<nLine.Upper; i++)  {
          ObjectMove("Line.Upper"+i,0,mLineUpper.DateTime[i][0],mLineUpper.Price[i][0]);
          ObjectMove("Line.Upper"+i,1,mLineUpper.DateTime[i][1],mLineUpper.Price[i][1]);
        } 
      }
      break;  //      
    case 20:
      //--------------------------------------------------------- 1 --
      if(nLine.Lower<=nVilka.Lower*2)  {
        mLineLower.DateTime[nLine.Lower-2][0]=ObjectGet("Line.Lower"+(nLine.Lower-2),OBJPROP_TIME1);
        mLineLower.DateTime[nLine.Lower-2][1]=ObjectGet("Line.Lower"+(nLine.Lower-2),OBJPROP_TIME2);
        mLineLower.Price[nLine.Lower-2][0]=ObjectGet("Line.Lower"+(nLine.Lower-2),OBJPROP_PRICE1);
        mLineLower.Price[nLine.Lower-2][1]=ObjectGet("Line.Lower"+(nLine.Lower-2),OBJPROP_PRICE2);
        //+------------------------------------------------------------------+
        mLineLower.DateTime[nLine.Lower-1][0]=ObjectGet("Line.Lower"+(nLine.Lower-1),OBJPROP_TIME1);
        mLineLower.DateTime[nLine.Lower-1][1]=ObjectGet("Line.Lower"+(nLine.Lower-1),OBJPROP_TIME2);
        mLineLower.Price[nLine.Lower-1][0]=ObjectGet("Line.Lower"+(nLine.Lower-1),OBJPROP_PRICE1);
        mLineLower.Price[nLine.Lower-1][1]=ObjectGet("Line.Lower"+(nLine.Lower-1),OBJPROP_PRICE2);
      }
      //--------------------------------------------------------- 2 --
      if(nLine.Lower >nVilka.Lower*2)  {
        for (i=0; i<nLine.Lower-4; i++)  {
          mLineLower.DateTime[i][0]=mLineLower.DateTime[i+2][0]; mLineLower.DateTime[i][1]=mLineLower.DateTime[i+2][1];
          mLineLower.Price[i][0]=mLineLower.Price[i+2][0]; mLineLower.Price[i][1]=mLineLower.Price[i+2][1];
        }
        mLineLower.DateTime[nLine.Lower-4][0]=ObjectGet("Line.Lower"+(nLine.Lower-2),OBJPROP_TIME1);
        mLineLower.DateTime[nLine.Lower-4][1]=ObjectGet("Line.Lower"+(nLine.Lower-2),OBJPROP_TIME2);
        mLineLower.Price[nLine.Lower-4][0]=ObjectGet("Line.Lower"+(nLine.Lower-2),OBJPROP_PRICE1);
        mLineLower.Price[nLine.Lower-4][1]=ObjectGet("Line.Lower"+(nLine.Lower-2),OBJPROP_PRICE2);
        //+------------------------------------------------------------------+
        mLineLower.DateTime[nLine.Lower-3][0]=ObjectGet("Line.Lower"+(nLine.Lower-1),OBJPROP_TIME1);
        mLineLower.DateTime[nLine.Lower-3][1]=ObjectGet("Line.Lower"+(nLine.Lower-1),OBJPROP_TIME2);
        mLineLower.Price[nLine.Lower-3][0]=ObjectGet("Line.Lower"+(nLine.Lower-1),OBJPROP_PRICE1);
        mLineLower.Price[nLine.Lower-3][1]=ObjectGet("Line.Lower"+(nLine.Lower-1),OBJPROP_PRICE2);
        //+------------------------------------------------------------------+
        ObjectDelete("Line.Lower"+(nLine.Lower-2)); ObjectDelete("Line.Lower"+(nLine.Lower-1));
        nLine.Lower--;nLine.Lower--;
        //+------------------------------------------------------------------+
        for (i=0; i<nLine.Lower; i++)  {
          ObjectMove("Line.Lower"+i,0,mLineLower.DateTime[i][0],mLineLower.Price[i][0]);
          ObjectMove("Line.Lower"+i,1,mLineLower.DateTime[i][1],mLineLower.Price[i][1]);
        } 
      }
      break;  //      
  }
  return;
}

//+---------------------------------------------------------------------------+
void DeleteOrders(int Type)  {     //     
  if(Type==10)  {
    //--------------------------------------------------------- 1 --
    mOrders[0][0]=0; mOrders[0][1]=""; mOrders[0][2]=""; mOrders[0][3]=""; mOrders[0][4]=0;
    ObjectDelete("Order.Buy"); ObjectDelete("OrderArrow.Buy");
    ObjectDelete("StopLoss.Buy"); ObjectDelete("StopLossArrow.Buy");
    ObjectDelete("LabelPrice.Buy"); ObjectDelete("LabelStopLoss.Buy");
  }
  if(Type==20)  {
    //--------------------------------------------------------- 2 --
    mOrders[1][0]=0; mOrders[1][1]=""; mOrders[1][2]=""; mOrders[1][3]=""; mOrders[1][4]=0;
    ObjectDelete("Order.Sell"); ObjectDelete("OrderArrow.Sell");
    ObjectDelete("StopLoss.Sell"); ObjectDelete("StopLossArrow.Sell");
    ObjectDelete("LabelPrice.Sell"); ObjectDelete("LabelStopLoss.Sell");
  }
  return;
}

//+---------------------------------------------------------------------------+
bool DrawOrdersBuy(int nBar)  {     //    Buy
double Price.Buy=Open[nBar];
double StopLoss.Buy;
  // -----  
  for (int i=nBar+1; i<Bars; i++)   {  //   
    StopLoss.Buy=iFractals(NULL,0,MODE_LOWER,i);
    if(StopLoss.Buy!=0)  {
      StopLoss.Buy=StopLoss.Buy-MarketInfo(Symbol(),MODE_SPREAD)*Point;
      break;
    }
  }
  // -----     
  // 1.       .
  // 2.        ().
  if(StopLoss.Buy>=ObjectGetValueByShift(NameLine.Buy,i) || StopLoss.Buy>=Price.Buy)  {
    return(false);
  }
  // -----     
  DeleteOrders(10);
  // -----    
  mOrders[0][0]=10;                                             //   ""   
  mOrders[0][1]=TimeToStr(Time[nBar],TIME_DATE|TIME_MINUTES);   //    "" 
  mOrders[0][2]=Price.Buy;                                      //   
  mOrders[0][3]=StopLoss.Buy;                                   //   
  mOrders[0][4]=0;                                              //   : 0-  , 1- 
  // ----- ,  
  if(ShowOrders)  {
    // -----    
    ObjectCreate("Order.Buy",OBJ_TREND,0,Time[nBar+25],Price.Buy,Time[nBar],Price.Buy);
    ObjectCreate("OrderArrow.Buy",OBJ_ARROW,0,Time[nBar+23],Price.Buy);
    ObjectSet("Order.Buy",OBJPROP_COLOR,Color.OrderBuy);  ObjectSet("OrderArrow.Buy",OBJPROP_COLOR,Color.OrderBuy);
    ObjectSet("Order.Buy",OBJPROP_WIDTH,Width.OrderBuy);  ObjectSet("OrderArrow.Buy",OBJPROP_WIDTH,Width.OrderBuy);
    ObjectSet("Order.Buy",OBJPROP_RAY,false);             ObjectSet("OrderArrow.Buy",OBJPROP_ARROWCODE,225);
    ObjectCreate("LabelPrice.Buy",OBJ_TEXT,0,Time[nBar+10],Price.Buy);
    ObjectSetText("LabelPrice.Buy","Buy: "+DoubleToStr(Price.Buy,Digits),Orders.FontSize, "Times New Roman", 
                                                                                            Color.OrderBuy);
    // -----    
    ObjectCreate("StopLoss.Buy",OBJ_TREND,0,Time[nBar+25],StopLoss.Buy,Time[nBar],StopLoss.Buy);
    ObjectCreate("StopLossArrow.Buy",OBJ_ARROW,0,Time[nBar+23],StopLoss.Buy);
    ObjectSet("StopLoss.Buy",OBJPROP_COLOR,Color.SLBuy);     ObjectSet("StopLossArrow.Buy",OBJPROP_COLOR,Color.SLBuy);
    ObjectSet("StopLoss.Buy",OBJPROP_WIDTH,Width.OrderBuy);  ObjectSet("StopLossArrow.Buy",OBJPROP_WIDTH,Width.OrderBuy);
    ObjectSet("StopLoss.Buy",OBJPROP_RAY,false);             ObjectSet("StopLossArrow.Buy",OBJPROP_ARROWCODE,251);
    ObjectCreate("LabelStopLoss.Buy",OBJ_TEXT,0,Time[nBar+10],StopLoss.Buy);
    ObjectSetText("LabelStopLoss.Buy","SL Buy: "+DoubleToStr(StopLoss.Buy,Digits),Orders.FontSize, "Times New Roman", 
                                                                                                    Color.SLBuy);
  }
  return(true);
}

//+---------------------------------------------------------------------------+
bool DrawOrdersSell(int nBar)  {     //    Sell
double Price.Sell=Open[nBar];
double StopLoss.Sell;
  // -----  
  for (int i=nBar; i<Bars; i++)   {  //   
    StopLoss.Sell=iFractals(NULL,0,MODE_UPPER,i);
    if(StopLoss.Sell!=0)  {
      StopLoss.Sell=StopLoss.Sell+MarketInfo(Symbol(),MODE_SPREAD)*Point;
      break;
    }
  }
  // -----     
  // 1.       .
  // 2.        ().
  if(StopLoss.Sell<=ObjectGetValueByShift(NameLine.Sell,i) || StopLoss.Sell<=Price.Sell)  {
    return(false);
  }
  // -----     
  DeleteOrders(20);
  // -----    
  mOrders[1][0]=20;                                             //   ""   
  mOrders[1][1]=TimeToStr(Time[nBar],TIME_DATE|TIME_MINUTES);   //    "" 
  mOrders[1][2]=Price.Sell;                                     //   
  mOrders[1][3]=StopLoss.Sell;                                  //   
  mOrders[1][4]=0;                                              //   : 0-  , 1- 
  // ----- ,  
  if(ShowOrders)  {
    // -----    
    ObjectCreate("Order.Sell",OBJ_TREND,0,Time[nBar+25],Price.Sell,Time[nBar],Price.Sell);
    ObjectCreate("OrderArrow.Sell",OBJ_ARROW,0,Time[nBar+23],Price.Sell+10*Point);
    ObjectSet("Order.Sell",OBJPROP_COLOR,Color.OrderSell);  ObjectSet("OrderArrow.Sell",OBJPROP_COLOR,Color.OrderSell);
    ObjectSet("Order.Sell",OBJPROP_WIDTH,Width.OrderSell);  ObjectSet("OrderArrow.Sell",OBJPROP_WIDTH,Width.OrderSell);
    ObjectSet("Order.Sell",OBJPROP_RAY,false);              ObjectSet("OrderArrow.Sell",OBJPROP_ARROWCODE,226);
    ObjectCreate("LabelPrice.Sell",OBJ_TEXT,0,Time[nBar+10],Price.Sell+10*Point);
    ObjectSetText("LabelPrice.Sell","Sell: "+DoubleToStr(Price.Sell,Digits),Orders.FontSize, "Times New Roman", 
                                                                                              Color.OrderSell);
    // -----    
    ObjectCreate("StopLoss.Sell",OBJ_TREND,0,Time[nBar+25],StopLoss.Sell,Time[nBar],StopLoss.Sell);
    ObjectCreate("StopLossArrow.Sell",OBJ_ARROW,0,Time[nBar+23],StopLoss.Sell+10*Point);
    ObjectSet("StopLoss.Sell",OBJPROP_COLOR,Color.SLSell);   ObjectSet("StopLossArrow.Sell",OBJPROP_COLOR,Color.SLSell);
    ObjectSet("StopLoss.Sell",OBJPROP_WIDTH,Width.OrderSell);ObjectSet("StopLossArrow.Sell",OBJPROP_WIDTH,Width.OrderSell);
    ObjectSet("StopLoss.Sell",OBJPROP_RAY,false);            ObjectSet("StopLossArrow.Sell",OBJPROP_ARROWCODE,251);
    ObjectCreate("LabelStopLoss.Sell",OBJ_TEXT,0,Time[nBar+10],StopLoss.Sell+10*Point);
    ObjectSetText("LabelStopLoss.Sell","SL Sell: "+DoubleToStr(StopLoss.Sell,Digits),Orders.FontSize, "Times New Roman", 
                                                                                                     Color.SLSell);
  }
  return;
}

//+---------------------------------------------------------------------------+
void SendMailSignals(int nBar, int SignalId)  {   //    e-mail  
string Mail.Message;
  switch(SignalId)  {
    //--------------------------------------------------------- 1 --
    case 10:
      Mail.Message="Buy signal!"+CharToStr(13)+"Symbol: "+Symbol()+CharToStr(13)+
                   "Timeframe: "+GetNameTF()+CharToStr(13)+"DateTime: "+mOrders[0][1]+CharToStr(13)+
                   "Price: "+mOrders[0][2]+CharToStr(13)+"StopLoss: "+mOrders[0][3];
      SendMail("Buy signal!",Mail.Message);
      break;
    //--------------------------------------------------------- 2 --
    case 11:
      Mail.Message="Attention! Stop Loss  Buy!"+CharToStr(13)+"Symbol: "+Symbol()+CharToStr(13)+
                   "Timeframe: "+GetNameTF()+CharToStr(13)+"DateTime: "+TimeToStr(Time[nBar],TIME_DATE|TIME_MINUTES)+
                   CharToStr(13)+"StopLoss: "+mOrders[0][3];
      SendMail("Attention! Stop Loss  Buy!",Mail.Message);
      break;
    //--------------------------------------------------------- 3 --
    case 20:
      Mail.Message="Sell signal!"+CharToStr(13)+"Symbol: "+Symbol()+CharToStr(13)+
                   "Timeframe: "+GetNameTF()+CharToStr(13)+"DateTime: "+mOrders[1][1]+CharToStr(13)+
                   "Price: "+mOrders[1][2]+CharToStr(13)+"StopLoss: "+mOrders[1][3];
      SendMail("Sell signal!",Mail.Message);
      break;
    //--------------------------------------------------------- 4 --
    case 21:
      Mail.Message="Attention! Stop Loss  Sell!"+CharToStr(13)+"Symbol: "+Symbol()+CharToStr(13)+
                   "Timeframe: "+GetNameTF()+CharToStr(13)+"DateTime: "+TimeToStr(Time[nBar],TIME_DATE|TIME_MINUTES)+
                   CharToStr(13)+"StopLoss: "+mOrders[1][3];
      SendMail("Attention! Stop Loss  Sell! ",Mail.Message);
      break;
  }
  return;
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                                |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    TimeFrame -  ( )      (0 -  )         |
//+----------------------------------------------------------------------------+
string GetNameTF(int TimeFrame=0) {
  if (TimeFrame==0) TimeFrame=Period();
  switch (TimeFrame) {
    case PERIOD_M1:  return("M1");
    case PERIOD_M5:  return("M5");
    case PERIOD_M15: return("M15");
    case PERIOD_M30: return("M30");
    case PERIOD_H1:  return("H1");
    case PERIOD_H4:  return("H4");
    case PERIOD_D1:  return("Daily");
    case PERIOD_W1:  return("Weekly");
    case PERIOD_MN1: return("Monthly");
    default:         return("UnknownPeriod");
  }
}

//+---------------------------------------------------------------------------+
bool CheckParameters()  {     //     
  if(nVilka.Upper<1 || nVilka.Lower<1)  {
    string  TextMessage="    !"+
                        " nVilka.Upper  nVilka.Lower    <() 1";
    Alert(TextMessage);
    return(false);
  }
  return(true);
}

void OrderOp(int ord, string val, int TakeProfit, int StopLoss, double lot)
{
   double TP,SL,ticket, pAsk, pBid;
   bool res=false;
   while(!res)
   {
      pAsk = MarketInfo(val,MODE_ASK);
      pBid = MarketInfo(val,MODE_BID);
      TP=0; SL=0;
   
      if(ord==OP_BUY)
      {
         TP=pAsk+TakeProfit*Point; if(TakeProfit==0) TP=0;
         SL=pBid-StopLoss*Point;   if(StopLoss==0) SL=0;
         ticket=OrderSend(val,OP_BUY,lot,pAsk,3,SL,TP,"",MG,0);
      }
      if(ord==OP_SELL)
      {
         TP=pBid-TakeProfit*Point; if(TakeProfit==0) TP=0;
         SL=pAsk+StopLoss*Point;   if(StopLoss==0) SL=0;
         ticket=OrderSend(val,OP_SELL,lot,pBid,3,SL,TP,"",MG,0);
      }
      if(ticket>0) res = true;
   }      
}

//+------------------------------------------------------------------+
int colOrders(int oType)
{
   int cnt,ao=0;
   for(cnt=OrdersTotal();cnt>0;cnt--)
   {
      OrderSelect(cnt-1, SELECT_BY_POS, MODE_TRADES);
      if(OrderMagicNumber()==MG && OrderType() == oType) ao++;
   }
   return(ao);
}

//+------------------------------------------------------------------+
int OrderCl(int ord)
{
   int cnt;
   for(cnt=OrdersTotal();cnt>0;cnt--)
   {
      OrderSelect(cnt-1, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()==OP_BUY  && ord==OP_BUY  && OrderMagicNumber()==MG) while (!OrderClose(OrderTicket(),OrderLots(),Bid,3)) { }
      if(OrderType()==OP_SELL && ord==OP_SELL && OrderMagicNumber()==MG) while (!OrderClose(OrderTicket(),OrderLots(),Ask,3)) { }
   }
}
//+------------------------------------------------------------------+
//+----------------------------------------------------------------------------+
//|                                                                            |
//|                                                     |
//|                                                                            |
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                          |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    op -                                       |
//+----------------------------------------------------------------------------+
string GetNameOP(int op) {
  switch (op) {
    case OP_BUY      : return("Buy");
    case OP_SELL     : return("Sell");
    case OP_BUYLIMIT : return("BuyLimit");
    case OP_SELLLIMIT: return("SellLimit");
    case OP_BUYSTOP  : return("BuyStop");
    case OP_SELLSTOP : return("SellStop");
    default          : return("Unknown Operation");
  }
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 18.07.2008                                                     |
//|   :        .      |
//+----------------------------------------------------------------------------+
color IIFc(bool condition, color ifTrue, color ifFalse) {
  if (condition) return(ifTrue); else return(ifFalse);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.02.2008                                                     |
//|   :        .      |
//+----------------------------------------------------------------------------+
string IIFs(bool condition, string ifTrue, string ifFalse) {
  if (condition) return(ifTrue); else return(ifFalse);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 28.11.2006                                                     |
//|   :     .           |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    pp -                                                 |
//|    sl -                                                 |
//|    tp -                                                 |
//|    ex -                                                       |
//+----------------------------------------------------------------------------+
void ModifyOrder(double pp=-1, double sl=0, double tp=0, datetime ex=0) {
  bool   fm;
  color  cl=IIFc(OrderType()==OP_BUY
              || OrderType()==OP_BUYLIMIT
              || OrderType()==OP_BUYSTOP, clModifyBuy, clModifySell);
  double op, pa, pb, os, ot;
  int    dg=MarketInfo(OrderSymbol(), MODE_DIGITS), er, it;

  if (pp<=0) pp=OrderOpenPrice();
  if (sl<0 ) sl=OrderStopLoss();
  if (tp<0 ) tp=OrderTakeProfit();
  
  pp=NormalizeDouble(pp, dg);
  sl=NormalizeDouble(sl, dg);
  tp=NormalizeDouble(tp, dg);
  op=NormalizeDouble(OrderOpenPrice() , dg);
  os=NormalizeDouble(OrderStopLoss()  , dg);
  ot=NormalizeDouble(OrderTakeProfit(), dg);

  if (pp!=op || sl!=os || tp!=ot) {
    for (it=1; it<=NumberOfTry; it++) {
      if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
      while (!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      fm=OrderModify(OrderTicket(), pp, sl, tp, ex, cl);
      if (fm) {
        if (UseSound) PlaySound(SoundSuccess); break;
      } else {
        er=GetLastError();
        if (UseSound) PlaySound(SoundError);
        pa=MarketInfo(OrderSymbol(), MODE_ASK);
        pb=MarketInfo(OrderSymbol(), MODE_BID);
        Print("Error(",er,") modifying order: ",ErrorDescription(er),", try ",it);
        Print("Ask=",pa,"  Bid=",pb,"  sy=",OrderSymbol(),
              "  op="+GetNameOP(OrderType()),"  pp=",pp,"  sl=",sl,"  tp=",tp);
        Sleep(1000*10);
      }
    }
  }
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 11.09.2008                                                     |
//|   :                               |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     ( ""  -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    ( -1  -  )                  |
//|    mn - MagicNumber                ( -1  -  )                    |
//+----------------------------------------------------------------------------+
void SimpleTrailing(string sy="", int op=-1, int mn=-1) {
  double po, pp;
  int    i, k=OrdersTotal();

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if ((OrderSymbol()==sy || sy=="") && (op<0 || OrderType()==op)) {
        po=MarketInfo(OrderSymbol(), MODE_POINT);
        if (mn<0 || OrderMagicNumber()==mn) {
          if (OrderType()==OP_BUY) {
            pp=MarketInfo(OrderSymbol(), MODE_BID);
            if (!TSProfitOnly || pp-OrderOpenPrice()>TStop.Buy*po) {
              if (OrderStopLoss()<pp-(TStop.Buy+TrailingStep-1)*po) {
                ModifyOrder(-1, pp-TStop.Buy*po, -1);
              }
            }
          }
          if (OrderType()==OP_SELL) {
            pp=MarketInfo(OrderSymbol(), MODE_ASK);
            if (!TSProfitOnly || OrderOpenPrice()-pp>TStop.Sell*po) {
              if (OrderStopLoss()>pp+(TStop.Sell+TrailingStep-1)*po || OrderStopLoss()==0) {
                ModifyOrder(-1, pp+TStop.Sell*po, -1);
              }
            }
          }
        }
      }
    }
  }
}
//+----------------------------------------------------------------------------+

